XWNMO(1)

NAME
xwnmo - Input Manager of the X Window System Version 11

SYNOPSIS
xwnmo [-option ...]

DESCRIPTION
The xwnmo is a input manager for Input Method of X Window System. It is based on [X Window System, Version 11 Input Method Specifications]. It provides a multi-language input environment for multiple clients in the X Window System Version 11. Clients can connect to it by using XIM library.

xwnmo supports multi-screen environment. xwnmo creates one window for Root-mode on each screen.

The conversion engine xwnmo use is the internationalized Wnn. It selects conversion server in accordance with language of clients. How many languages xwnmo supports depend on the configuration file (ximconf). Please refer the manual of ximconf.

Xwnmo supports the following inputstyles:
    ( XIMPreeditArea | XIMStatusArea )
    ( XIMPreeditPosition | XIMStatusArea )
    ( XIMPreeditNothing | XIMStatusNothing )
    ( XIMPreeditCallbacks | XIMStatusArea )
    ( XIMPreeditArea | XIMStatusCallbacks )
    ( XIMPreeditPosition | XIMStatusCallbacks )
    ( XIMPreeditCallbacks | XIMStatusCallbacks )

If you attempt to connect xwnmo by using XIM library, You must set modifiers _XWNMO.

Concretely,
    XSetLocaleModifiers("@im=_XWNMO");
    or
    set environment XMODIFIERS=@im=_XWNMO and XSetLocaleModifiers("");.

For feather information about XIM library, please see the chapter 13 of Xdoc or [X Window System, Version 11 Input Method Specifications].

XML
According to Input Method Specifications, the locale which input method use is only one and static locale. Thence xwnmo provides only one languange environment which depends on the current locale of XOpenIM(). And you could not change this environment. But if libX11.a was compiled with XML define, clients can use multi locale environment. In other words, you can change current languange environment on the fly by changing current locale. The way to use its environment is the following:

Creating environment
    Call XmlOpenIM() instead of XOpenIM() ,set XNCurrentLanguage argument of XIC and call XCreateIC(). So xwnmo attempts to create as many language environment as possible and set current environment to the locale set XNCurrentLanguage. If you don't set XNCurrentLanguage current environment is the first environment xwnmo created. A syntax of XNCurrentLanguage follows.
    current_language = <language>'_'<territory>

Changing environment
    If you want to change current languange environment, set XNCurrentLanguage argument and call XSetICValues().

Xwnmo accept that XML clients and NON_XML clients connect xwnmo at the same time.

CHANGING LOCALE
Xwnmo has two interfaces for changing current languange environment. One is change_locale_ct function. This function is good only when current locale is wr_WR.ct. You can write it in uumkey-file. A syntax of change_locale_ct follows.

change_locale_ct <key> [ <key> ... ]

Other is change_locale function. You can write it in uumkey-file. A syntax of change_locale follows.

change_locale <key> [ <key> ... ]

This function is good only when you set XNChangeLocaleCB argument. The value of this argument is a pointer of callback function. This function will be call by input method when you change current languange environment of xwnmo. A interface of this function follows.

void ChangeLocaleCB(char *locale)

XJp
Xwnmo is able to support XJp protocol. If You compile xwnmo with XJP define, it supports "Communication Kit" part of XJp protocol. And if You compile xwnmo with XJP and XJP_DIRECT define, it supports "Direct Interface" part of XJp protocol.

SEP
Xwnmo is able to support SEP(SpotLocation Extended Protocol). If You compile xwnmo with SPOT define, it supports SEP. And please use _XipChangeSpot() function. it's interface follows.

int _XipChangeSpot(ic, spot_x, spot_y)
    XIC ic;
    short spot_x, spot_y;

ic:    Specifies the input context.
spot_x, spot_y:    Specifies the coordinates of the ``spot''.

OPTIONS
Xwnmo accepts the following options:

-D server-name
    This option specifies the machine name of conversion server. If this isn't set, first JSERVER environment is referred. And if it isn't set, xwnmo attempts to connect "jserver" machine. And if it's connect failed, xwnmo attempts to connect local machine.

-n user-name
    This option specifies the user name which is used as env-name of Wnn. If this isn't set, first WNNUSER environment is referred. And if it isn't set, the user name of process is referred.

-lc language-name
    This option specifies the language name which is referred as the language environment of Root-mode. If this isn't set, first LANG environment is referred. And if it isn't set, the default is ja_JP. A syntax of language-name follows.
    language = <language>'_'<territory>

-k uumkey-file-name
    This option specifies the path name of uumkey-file. For feather information about uumkey-file, please see Wnn manual.

-r romkan-file-name
    This option specifies the directory name of romkan-file. For feather information about romkan-file, please see Wnn manual.

-X convert-key-file-name
    This option specifies the path name of convert-key-file. The convert-key-file contains the relation between keys of X and keys of Wnn. The default is "/usr/local/lib/wnn/cvt_xim_tbl". For feather information about convert-key-file, please see the manual of cvt_xim_tbl.

-F convert-function-file-name
    This option specifies the path name of convert-function-file. The convert-function-file contains the relation between function keys of X and keys of Wnn. This file is only for older version xwnmo. Please use cvt_xim_tbl as much as possible. For feather information about convert-function-file, please see the manual of cvt_fun_tbl.

-M convert-meta-file-name
    This option specifies the path name of convert-meta-file. The convert-meta-file contains the relation between meta keys of X and keys of Wnn. This file is only for older version xwnmo. Please use cvt_xim_tbl as much as possible. For feather information about convert-meta-file, please see the manual of cvt_meta_tbl.

-display display
    This option specifies the X server to connect; see X(1).

-help
    This causes xwnmo to print out a verbose message describing its options.

-ju xjtuil-name
    This option specifies the path name of xjutil which is the dictionary utility manager. The default is "/usr/bin/X11/xjutil".

-EM This causes that the menu for exit is available when a mouse pointer is pushed on Root-mode window. The default is available.

+EM This causes that the menu for exit is disable. Please use killxwnmo for exit.

-SU This causes that all windows xwnmo creates have SaveUnder attribute. The default is those don't have.

The following options affects windows for Root-mode on all screens.

-fs font-name-list
    This option specifies the list of font name. The fontset of Root-mode window is created from this list. The default is depend on the locale. A syntax of this list follows.
    font-name-list = <fontname>{','fontname}

-geometry geometry
    This option specifies the preferred size and position of Root-mode window. see X(1)

-fg color
    This option specifies the color to use for displaying text of Root-mode window. The default is ``black.''

-bg color
    This option specifies the color to use for the background of Root-mode window. The default is ``white.''

-bd color
    This option specifies the color to use for the border of Root-mode window. The default is ``black.''

-bw number
    This option specifies the width in pixels of the border surrounding Root-mode window.

-iconic
    This option indicates that xwnmo should ask the window manager to start it as an icon rather than as the normal window. If the -RV option is specified or "rootVisible" resource is specified as ``True'', this option becomes void.

#geom
    This option specifies the preferred position of the icon window. It is shorthand for specifying the ``*iconGeometry'' resource.

-h  This causes xwnmo to wake up in conversion off mode.

-H  This causes xwnmo to wake up in conversion on mode. The default is off mode.

-RV This causes xwnmo to unmap Root-mode window when henkan mode is off or no client uses Root-mode. This option make -iconic option void and set "iconic" resource as ``False''.

RESOURCES
Xwnmo accepts the following resource names and classes:

serverName (class ServerName)
    This option specifies the machine name of conversion server. If this isn't set, first JSERVER environment is referred. And if it isn't set, xwnmo attempts to connect "jserver" machine. And if it's connect failed, xwnmo attempts to connect local machine.

userName (class UserName)
    Specifies the user name which is used as env-name of Wnn. If this isn't set, first WNNUSER environment is referred. And if it isn't set, the user name of process is referred.

ximrcName (class XimrcName)
    Specifies the path name of ximrc-file which is a start up file of xwnmo. If this isn't set or there is not it, first $HOME/.ximrc is referred. And if it doesn't exist, the default is "/usr/local/lib/wnn/ximrc". For feather information about ximrc-file, please see the manual of ximrc-file.

cvtximName (class CvtximName)
    Specifies the path name convert-key-file. The convert-key-file contains the relation between function keys of X and keys of Wnn. The default is "/usr/local/lib/wnn/cvt_xim_tbl". For feather information about convert-key-file, please see the manual of cvt_xim_tbl.

cvtfunName (class CvtfunName)
    Specifies the path name convert-function-file. The convert-function-file contains the relation between function keys of X and keys of Wnn. This file is only for older version xwnmo. Please use cvt_xim_tbl as much as possible. For feather information about convert-function-file, please see the manual of cvt_fun_tbl.

cvtmetaName (class CvtmetaName)
    Specifies the path name of convert-meta-file. The convert-meta-file contains the relation between meta keys of X and keys of Wnn. This file is only for older version xwnmo. Please use cvt_xim_tbl as much as possible. For feather information about convert-meta-file, please see the manual of cvt_meta_tbl.

xjutilName (class XjutilName)
    Specifies the path name of xjutil which is the dictionary utility manager. The default is "/usr/bin/X11/xjutil".

langName (class LangName)
    Specifies the locale name which is referred as the language environment of Root-mode. If this isn't set, first LANG environment is referred. And if it isn't set, the default is ja_JP. A syntax of language-name follows.
    language = <language>'_'<territory>

exitMenu (class ExitMenu)
    Indicates that the menu for exit is available when a mouse pointer is pushed on Root-mode window. The default is ``True''.

saveUnder (class SaveUnder)
    Indicates that all windows xwnmo creates have SaveUnder attribute. The default is those don't have.

The following options can be specified for the window for Root-mode on each screen separately. the sub-name and sub-class of each screen are screenN and ScreenN. Then N are specified the number of screen.

foreground (class Foreground)
    Specifies the color to use for displaying text of Root-mode window. The default is ``black''.

background (class Background)
    Specifies the color to use for the background of Root-mode window. The default is ``white''.

borderColor (class BorderColor)
    Specifies the color to use for the border of Root-mode window. The default is ``black''.

iconic (class Iconic)
    Indicates that xwnmo should ask the window manager to start it as an icon rather than as the normal window. If the -RV option is specified or "rootVisible" resource is specified as ``True'', this resource is specified as ``False''. The default is ``False''.

geometry (class Geometry)
    Specifies the preferred size and position of Root-mode window.

iconGeometry (class IconGeometry)
    Specifies the preferred position of the icon window.

borderWidth (class BorderWidth)
    Specifies the width in pixels of the border surrounding Root-mode window.

fontSet (class FontSet)
    Specifies the list of font name. The fontset of Root-mode window is created from this list. The default is depend on the locale. A syntax of this list follows.
    font-name-list = <fontname>{','fontname}

rootVisible (class RootVisible)
    Indicates that xwnmo should unmap Root-mode window when henkan mode is off or no client uses Root-mode. The default is ``False''. This resource make -iconic option void and set "iconic" resource as ``False''.

SEE ALSO
killxwnmo(1X), ximrc(4X), cvt_xim_tbl(4X), cvt_fun_tbl(4X), cvt_meta_tbl(4X)
Wnn Manual (in the Wnn source directory)

COPYRIGHT
Copyright 1992, 1992 by OMRON Corporation
Copyright 1992, 1992 by Massachusetts Institute of Technology

AUTHOR
Seiji Kuwari (OMRON Corporation)